Attribute VB_Name = "Module1"
Public HVCmd As Boolean

Public Function Open_DDE_Link() As Integer
Const conDDENoApp = 282  'error # if HomeVision application isn't running
Dim result
'Use this function first to open the DDE links to HomeVision

On Error GoTo ExitError

    'This link is used to poke commands to HomeVision:
    Form1.DDECommand.LinkTopic = "HOMEVIS|DDE"
    Form1.DDECommand.LinkItem = "DDECommand"
    Form1.DDECommand.LinkMode = vbLinkManual
    
    'This link is used to receive acknowledgement from HomeVision
    'that a previous poke command was received:
    Form1.DDECommandAcknowledge.LinkTopic = "HOMEVIS|DDE"
    Form1.DDECommandAcknowledge.LinkItem = "DDECommandAcknowledge"
    Form1.DDECommandAcknowledge.LinkMode = vbLinkAutomatic
   
    'This link is used to receive messages from HomeVision:
    Form1.DDEMessage.LinkTopic = "HOMEVIS|DDE"
    Form1.DDEMessage.LinkItem = "DDEMessage"
    Form1.DDEMessage.LinkMode = vbLinkAutomatic
    
    'This link is used to send an acknowledgement to HomeVision
    'that a previous message was received:
    Form1.DDEMessageAcknowledge.LinkTopic = "HOMEVIS|DDE"
    Form1.DDEMessageAcknowledge.LinkItem = "DDEMessageAcknowledge"
    Form1.DDEMessageAcknowledge.LinkMode = vbLinkManual

    Open_DDE_Link = 0   'OK
    Exit Function

ExitError:
    If Err = conDDENoApp Then
        MsgBox ("HomeVision is not running.  Please start it.")
    Else
        MsgBox ("Unknown error opening DDE link")
    End If
    
    Open_DDE_Link = -1   'ERROR

End Function
Public Function Send_DDE_Command(CommandToSend As String) As Integer
'This function sends the DDE command (a text string) to HomeVision

On Error GoTo ExitError

    HVCmd = True
    'First, set DDECommand label to the desired command:
    Form1.DDECommand = CommandToSend
    
    'Now poke it to HomeVision:
    Form1.DDECommand.LinkPoke

    'Indicate command sent to HomeVision and waiting for acknowledgement:
    DDE_Command_In_Process = True
    Send_DDE_Command = 0   'OK
    
    Exit Function
    
ExitError:
    Send_DDE_Command = -1   'ERROR

End Function

Public Function Send_DDE_Message_Ack() As Integer
'After receiving a message from HomeVision, use this function to
'send an acknowledgement to HomeVision

On Error GoTo ExitError
    
'Set OK acknowledgement text (alternate between "OK 1" and "OK 2"):
If Form1.DDEMessageAcknowledge <> "OK 1" Then
    Form1.DDEMessageAcknowledge = "OK 1"
Else
    Form1.DDEMessageAcknowledge = "OK 2"
End If

'Now send it to HomeVision using the LinkPoke method:
Form1.DDEMessageAcknowledge.LinkPoke

Send_DDE_Message_Ack = 0   'OK
Exit Function

ExitError:
Send_DDE_Message_Ack = -1   'ERROR

End Function
